<?php
/**
 * @name добавление заказа в базу, формирование платежных форм
 */
if( !defined('DATALIFEENGINE') ) {
    header( "HTTP/1.1 403 Forbidden" );
    header ( 'Location: ../../' );
    die( "Hacking attempt!" );
}


header("Content-Type: text/html; charset=utf-8");

// PAYANYWAY BEGIN
const paw_kassa_VAT0     = '1104';  // НДС 0%
const paw_kassa_VAT10    = '1103';  // НДС 10%
const paw_kassa_VAT18    = '1102';  // НДС 18%
const paw_kassa_VATNOVAT = '1105';  // НДС не облагается
const paw_kassa_VATWR10  = '1107';  // НДС с рассч. ставкой 10%
const paw_kassa_VATWR18  = '1106';  // НДС с рассч. ставкой 18%

function monetaPayURLResponse($mnt_id, $mnt_transaction_id, $mnt_data_integrity_code, $success = false,
    $repeatRequest = false, $echo = true, $die = true, $kassa_inventory = null, $kassa_customer = null, $kassa_delivery = null)
{
    if ($success === true)
        $resultCode = '200';
    elseif ($repeatRequest === true)
        $resultCode = '402';
    else
        $resultCode = '500';
    $mnt_signature = md5($resultCode.$mnt_id.$mnt_transaction_id.$mnt_data_integrity_code);
    $response = '<?xml version="1.0" encoding="UTF-8" ?>'."\n";
    $response .= "<MNT_RESPONSE>\n";
    $response .= "<MNT_ID>{$mnt_id}</MNT_ID>\n";
    $response .= "<MNT_TRANSACTION_ID>{$mnt_transaction_id}</MNT_TRANSACTION_ID>\n";
    $response .= "<MNT_RESULT_CODE>{$resultCode}</MNT_RESULT_CODE>\n";
    $response .= "<MNT_SIGNATURE>{$mnt_signature}</MNT_SIGNATURE>\n";
    if (!empty($kassa_inventory) || !empty($kassa_customer) || !empty($kassa_delivery))
    {
        $response .= "<MNT_ATTRIBUTES>\n";
        foreach (array('INVENTORY' => $kassa_inventory, 'CUSTOMER' => $kassa_customer, 'DELIVERY' => $kassa_delivery) as $k => $v)
            if (!empty($v))
                $response .= "<ATTRIBUTE><KEY>{$k}</KEY><VALUE>{$v}</VALUE></ATTRIBUTE>\n";
        $response .= "</MNT_ATTRIBUTES>\n";
    }
    $response .= "</MNT_RESPONSE>\n";
    if ($echo === true)
    {
        header("Content-type: application/xml");
        echo $response;
    }
    else
        return $response;
    if ($die === true)
        die;
    return '';
}
// PAYANYWAY END

// значит пользователь только собирается перейти на страницу с выбором способа оплаты
if(!empty($_POST["payment_start"])){

    // payment_delivery - самовывоз - название выбранного маркера
    // delivery_city - выбранный город

    unset($_POST["payment_start"]);

    // номер покупки
    $order_id = file_get_contents(ENGINE_DIR . '/modules/kylshop/order_id.txt');
    $order_number = (int)$order_id + 1;
    $order_file = ENGINE_DIR . '/modules/kylshop/order_id.txt';
    $fp = fopen($order_file, "w");
    flock($order_file, LOCK_EX);
    fwrite($fp, $order_number);
    flock($order_file, LOCK_UN);

    // получаем существующие поля
    $fields_source = json_decode(file_get_contents(ENGINE_DIR . "/modules/kylshop/fields.json"), true);

    // в первую очередь заносим выбранные пользователем товары в переменную goods
    $goods = '';
    if(!empty($_POST["goods"])){
        $goods = json_decode($_POST["goods"], true);
        if(!is_array($goods)) die("Sorry! Invalid parameters of goods");
    }
    unset($_POST["goods"]);

    // перебираем все товары из корзины и проверяем на правильность отправки данных
    $where = "";
    foreach ($goods as $good) {
        $g_id = explode("_", $good["id"]);
        $where .= "id='{$g_id[0]}' OR ";
    }
    unset($g_id);
    $where = substr($where, 0, -4);

    // получаем массив новостей из базы
    $news = $db->super_query( "SELECT id, kylshop, filter FROM " . PREFIX . "_post WHERE " . $where, true );

    // v 3.4
    $filter_file = json_decode(file_get_contents(ENGINE_DIR . '/modules/kylshop/filter.json'), true);


    foreach ($news as $row) {

        $kylshop = unserialize($row["kylshop"]);

        $price = $kylshop["ks_price"];

        // если есть скидка
        if(!empty($kylshop["ks_sale"])){
            if($kylshop["ks_sale_type"] == "%") $price = (float)$price - ((float)$price * (int)$kylshop["ks_sale"]) / 100;
            else $price = (float)$price - (int)$kylshop["ks_sale"];
        }
        $price = round($price, 2);


        // v 3.4
        $filter_source = explode("||", $row["filter"]);
        $filter_prices = json_decode($filter_source[1], true);

        $tmp_filter = [];
        foreach ($filter_file["value"] as $key_title => $item) {
            $j = 0;
            foreach ($item as $it) {

                if(!empty($filter_prices[$key_title."_".$j])){
                    $tmp_filter[$it] = ["title" => $it, "price" => $filter_prices[$key_title."_".$j]];
                } else{
                    $tmp_filter[$it] = ["title" => $it, "price" => $price];
                }
                $j++;
            }
        }

        // обходим товары с фильтрами, и если цена не совпадает, значит покупатель ковырял код и пытался изменить цену товара через код, в таком случае можнопослать его на ...
        foreach ($goods as $good) {
            if(!empty($good["filter_val"]) && $tmp_filter[$good["filter_val"]]["price"] != $good["price"]) die("Извините, что-то пошло не так!");
        }
        // v 3.4 end

    }

    $total = 0; // общая сумма
    foreach ($goods as $good) {
        $total = $total + (str_replace(",", ".", $good["price"]) * (int)$good["count"]);
    }
    $total = round($total, 2);

    $data = [];

    // доставка по умолчанию false
    $delivery = false;

    // заносим данные в базу
    foreach ($_POST as $key => $item) {

        // если был выбран пункт самовывоза
        if(!empty($_POST["payment_delivery"])){
            $data["Пункт выдачи"] = trim(htmlspecialchars(strip_tags($_POST["payment_delivery"])));
            unset($_POST["payment_delivery"]);
        }


        // включена ли доставка
        // если включена и доставка - город и сумма превышает допустимую
        if($ks_config["delivery_power"] == true){
            if($key == "delivery_city"){
                $data["Город"] = trim(htmlspecialchars(strip_tags($_POST["delivery_city"])));
                $delivery = true;
            }
            // если самовывоз
            /*if(trim(mb_strtolower($item, 'UTF-8')) == "самовывоз"){

            }*/
        }

        if(!empty($fields_source[$key]["admin"])) $title = $fields_source[$key]["admin"];
        else $title = $fields_source[$key]["title"];
        $title = str_replace("*", "", $title);

        if(!empty($title)) $data[$title] = str_replace("\r\n", "", trim($item));
    }

    // если доставка в другой город и сумма заказа превышает допустимую
    if($delivery === true && $total > $ks_config["max_total_delivery"]){
        $total = $total + str_replace(",", ".", $ks_config["price_delivery"]);
    }

    $total = str_replace(",", ".", $total);

    $data = json_encode($data, JSON_UNESCAPED_UNICODE);

    // код покупки
    if(!empty($ks_config["order_code"])) $order_code = $ks_config["prefix_order"] . date($ks_config["order_code"], time());
    else $order_code = $ks_config["prefix_order"] . round(microtime(true) * 1000);

    // id пользователя
    // если разрешено покупать гостям
    if($ks_config["payment_guest"] == true){

        // если это гость
        if($member_id["user_group"] == "5") $user_id = "0";
        $user_id = $member_id["user_id"];

    // если не разрешено покупать гостям
    } else{

        // если это гость
        if($member_id["user_group"] == "5") die("Sorry! Guests are not allowed to buy goods!");
        $user_id = $member_id["user_id"];
    }




    $time = time();
    $secret_key = sha1($order_id + $ks_config["secret_key_payment"] . ":kylaksizov");

    $goods = json_encode($goods, JSON_UNESCAPED_UNICODE);

    $goods_info = json_decode($goods, true);
    if(count($goods_info) == 1) $goods_title = "(" . array_shift($goods_info)["title"] . ")";
    else $goods_title = "№" . $order_id;

    // заносим данные в базу
    $db->query("INSERT INTO " . PREFIX . "_kylshop_buy (order_id, order_code, user_id, fields, goods, total, time, secret_key, status)
		VALUES ('{$order_id}', '{$order_code}', '{$user_id}', '{$data}', '{$goods}', '{$total}', '{$time}', '{$secret_key}', '0')");

    $id = $db->insert_id();


    /**
     * @name выводим все подключаемые модули оплаты,
     * если включен прием платежей на сайте
     */
    if($ks_config["payments_power"] == true){


        $payment_init = '<div id="payments">';
        foreach (scandir(ENGINE_DIR . '/modules/kylshop/payments') as $file) {
            $config_app = "";
            if($file != "." && $file != ".." && $file != "Example"){
                if(file_exists(ENGINE_DIR . '/modules/kylshop/payments/' . $file . '/config.json')){

                    $config_payment = json_decode(file_get_contents(ENGINE_DIR . '/modules/kylshop/payments/' . $file . '/config.json'));

                    // подключаем главный класс системы оплаты
                    include (DLEPlugins::Check(ENGINE_DIR . '/modules/kylshop/payments/' . $file . '/'.$file.'.php'));

                    // если класс существует
                    if(class_exists($file)){

                        $payment = new $file($config_payment, $config);

                        // если метод вывода кнопки или формы существует
                        if(method_exists($payment, "init")){

                            // выводим форму или кнопку для перехода на страницу оплаты и передаем id добавленой записи и общую сумму
                            $payment_init .= '<div>
                                <img src="'.$config["http_home_url"]."templates/".$config["skin"].$config_payment->img.'" alt="'.$config_payment->name.'" class="payment_img">
                                '.$payment->init($id, $total, $secret_key, $data, $goods)/* $data - данные с формы */.'
                            </div>';
                        }
                    }
                }
            }
        }
        $payment_init .= '</div>';

        # TODO одинаковый функционал!
        // отправляем информацию о заказе на почту администратору
        include_once (DLEPlugins::Check(ENGINE_DIR . '/classes/mail.class.php'));

        $email_admin = $db->super_query( "SELECT * FROM " . PREFIX . "_users where user_group='1' LIMIT 0,1" );
        $mail = new dle_mail( $config, 1 );
        $mail->send( $email_admin["email"], "Новый заказ", 'На сайте появился новый заказ на сумму: <b>'.$total.' '.$ks_config["currency"].'</b>.<br>Товар ' . $goods_title );
        //if( $mail->send_error ) msgbox( "Ошибка!", "Failed" );
        // Таблица с товарами
        //$goods .= '<script>$(function(){localStorage.clear();})</script>';

    // если оплата выключена
    } else{

        # TODO одинаковый функционал!
        // отправляем информацию о заказе на почту администратору
        include_once (DLEPlugins::Check(ENGINE_DIR . '/classes/mail.class.php'));

        $email_admin = $db->super_query( "SELECT * FROM " . PREFIX . "_users where user_group='1' LIMIT 0,1" );
        $mail = new dle_mail( $config, 1 );
        $mail->send( $email_admin["email"], "Новый заказ", 'На сайте появился новый заказ на сумму: <b>'.$total.' '.$ks_config["currency"].'</b>.<br>Товар ' . $goods_title );
        //if( $mail->send_error ) msgbox( "Ошибка!", "Failed" );
        // Таблица с товарами
        //$goods .= '<script>$(function(){localStorage.clear();})</script>';

        $payment_init = $ks_config["order_text"];
    }

}

// Обрабатываем скрытые платежы
if(!empty($_GET["payment"])) {

    $payment_param = explode("_", $_GET["payment"]);

    $config_payment = json_decode(file_get_contents(ENGINE_DIR . '/modules/kylshop/payments/' . $payment_param[0] . '/config.json'));

    // подключаем главный класс системы оплаты
    include(DLEPlugins::Check(ENGINE_DIR . '/modules/kylshop/payments/' . $payment_param[0]. '/' . $payment_param[0] . '.php'));

    $method = $payment_param[1];

    // если класс существует
    if (class_exists($payment_param[0])) {

        $payment = new $payment_param[0]($config_payment, $config);
        // если метод вывода кнопки или формы существует
        if ($method == "success" && method_exists($payment, "success")) {

            $result = $payment->success();


            /**
             * @name УСПЕШНАЯ ОПЛАТА
             * ===========================
             */
            // если метод вернул ID заказа
            if(is_numeric($result)){


                // получаем заказ из базы
                $order = $db->super_query( "SELECT * FROM " . PREFIX . "_kylshop_buy WHERE id = '{$result}'" );
                $db->query( "UPDATE  " . PREFIX . "_kylshop_buy set status='1' WHERE order_id = '{$result}'" );

                $goods = json_decode($order["goods"], true);

                # TODO одинаковый функционал!
                // отправляем информацию о заказе на почту администратору
                include_once (DLEPlugins::Check(ENGINE_DIR . '/classes/mail.class.php'));

                $email_admin = $db->super_query( "SELECT * FROM " . PREFIX . "_users where user_group='1' LIMIT 0,1" );
                $mail = new dle_mail( $config, 1 );
                $mail->send( $email_admin["email"], "Заказ ".$order["order_code"]." оплачен!", "На сайте новая покупка!<br>Заказ №" . $order["order_code"] . "<br>Сумма заказа: " . $order["total"] . " " . $ks_config["currency"] . '.<br>Товар ' . $goods_title );


                // если email покупателя есть, отправляем ему сообщение
                if(!empty($order["email"])){

                    $mail_payer = new dle_mail( $config, 1 );
                    $mail_payer->send( $order["email"], "Заказ ".$order["order_code"]." оплачен!", "Ваш товар оплачен!<br>Заказ №" . $order["order_code"] . "<br>Сумма заказа: " . $order["total"] . " " . $ks_config["currency"] . '.<br>Товар ' . $goods_title );
                }

                $where = "";
                foreach ($goods as $news_id) {
                    if(ctype_digit($news_id["id"]))
                        $where .= " id = '{$news_id["id"]}' OR ";
                }

                if(!empty($where)){
                    $where = substr($where, 0, -4);
                    $news = $db->super_query( "SELECT id, kylshop FROM " . PREFIX . "_post WHERE" . $where, true );

                    foreach ($news as $key => $goods_info) {

                        $goods_params = unserialize($goods_info["kylshop"]);

                        // если есть запрос на перевод в группу
                        if(!empty($goods_params["after_payment_group"]) && ctype_digit($goods_params["after_payment_group"])){

                            // обновляем группу пользователя
                            $db->query( "UPDATE  " . USERPREFIX . "_users set user_group='{$goods_params["after_payment_group"]}' WHERE user_id = '{$order["user_id"]}'" );
                        }


                        // если нужно отнять кол-во товара
                        if(!empty($goods_params["ks_count_goods"]) && $goods_params["ks_count_goods_minus"] == "1"){

                            // отнимаем
                            $result_count = (int)$goods_params["ks_count"] - (int)$goods[$goods_info["id"]]["count"];

                            if($result_count < 0) $result_count = 0;

                            $goods_params["ks_count"] = $result_count;
                            $goods_params = serialize($goods_params);
                            $db->query( "UPDATE  " . USERPREFIX . "_post set kylshop='{$goods_params}' WHERE id = '{$goods_info["id"]}'" );
                        }


                        // если задано сообщение на почту
                        if(!empty($goods_params["after_payment_post"])){

                            $mail_send = new dle_mail( $config, 1 );
                            $mail_payer->send( $order["email"], "Заказ №".$order["order_code"], $goods_params["after_payment_post"] );
                        }
                    }
                }

                if($_GET["payment"] == 'robokassa_result') die("OK$result\n");
                // PAYANYWAY BEGIN
                if($_GET["payment"] == 'payanyway_success')
                {
                    $kassa_inventory = [];
                    foreach ($goods as $item) {
                        $kassa_inventory[] = [
                            'name' => trim(preg_replace("/&?[a-z0-9]+;/i", "", htmlspecialchars($item['title']))),
                            'price' => number_format($item['price'], 2, '.', ''),
                            'quantity' => $item['count'],
                            'vatTag' => paw_kassa_VATNOVAT
                        ];
                    }
                    $kassa_customer = null;
                    if(!empty($order["email"])) $kassa_customer = $order["email"];
                    if(!empty($order["Email"])) $kassa_customer = $order["Email"];
                    if(!empty($order["E-mail"])) $kassa_customer = $order["E-mail"];
                    if(!empty($order["E-Mail"])) $kassa_customer = $order["E-Mail"];
                    monetaPayURLResponse($config_payment->mnt_id, $result, $config_payment->mnt_secret,
                        true, false, true, true, json_encode($kassa_inventory), $kassa_customer);
                }
                // PAYANYWAY END

                // перенаправляем клиента по адресу в конфиге модуля оплаты
                if(!empty($config_payment->success_url)) header("Location: " . $config_payment->success_url);
                else header("Location: /");

            // если false
            } else{
                if(!empty($config_payment->fail_url)) header("Location: " . $config_payment->fail_url);
                else header("Location: /");
            }

        // если метода такого нет, просто перенаправляем пользователя на главную
        } else header("Location: " . $config_payment->success_url);
    }
}